/***************************************************************************
                          sankakuw.h  -  description
                             -------------------
    begin                : Thu Nov 21 2002
    copyright            : (C) 2002 by Nobuhiro Kuroiwa
    email                : nobu@iastate.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SANKAKUW_H
#define SANKAKUW_H
#include "SDL/SDL.h"
#include "SDL/sge.h"
#include "paragui/paragui.h"
#include "paragui/pgapplication.h"
#include "paragui/pgbutton.h"
#include "paragui/pgthemewidget.h"
#include "paragui/pgimage.h"
#include "paragui/pgeventobject.h"
#include "paragui/pglineedit.h"
#include "paragui/pglabel.h"
#include "sankaku.h"

/**
  *@author Nobuhiro Kuroiwa
  */
#define	DEFAULT_FILE_IN		"mercator.bmp"
#define	DEFAULT_FILE_OUT	"tetrahed.bmp"
#define	DEFAULT_RESOLUTION	"300"
#define	DEFAULT_SIZE		"300"

class SankakuWindow : public PG_EventObject, public SankakuCallBack{
public:
	SankakuWindow();
	~SankakuWindow();

	PARAGUI_CALLBACK( go_handler);
	PARAGUI_CALLBACK( exit_handler);
	PARAGUI_CALLBACK( load_handler);
	PARAGUI_CALLBACK( save_handler);
	bool		isReady();
	void show();
	void reportBox(		SDL_Rect	rect, unsigned short trig_index);
	void reportPercent(	int			per);

	SDL_Surface	*sfc_trig2show;
protected:
	Sankaku		*psankaku;
	bool		ready2go; 
	SDL_Thread	*thread;
	PG_Image	*pimg_mercator;
	PG_Image	*pimg_result;

	PG_Point 	pos_go,
				pos_exit,
				pos_load,
				pos_save,
				pos_result,
				pos_mercator;
	SDL_Surface	*sfc_mercator2show;
	SDL_Surface *sfc_result2show;
	PG_Button	*pbtn_go;
	PG_Button	*pbtn_exit;
	PG_Button	*pbtn_load;
	PG_Button	*pbtn_save;
	PG_LineEdit	*pedt_load;
	PG_LineEdit	*pedt_save;
	PG_LineEdit	*pedt_reso;// resolution, how many pieces in a side
	PG_LineEdit	*pedt_size;// size of triangle
	PG_Label	*plbl_reso;
	PG_Label	*plbl_size;
	float		magnification;
	Uint32		colour[4];
	//SDL_Color	color[ 4];

	void		showAllButtons();
	void		hideAllButtons();
	bool		initSankakuWindow();
	bool		makeThumbNail();
	static int	letsDance( void *param);	
};

#endif
